/* El tipo Pila se comporta como una Pila de nmeros si numeroPilaActual es 0, pero
 * se comporta como una lista de sentencias en caso contrario.
 * Podran haberse utilizado dos tipos diferentes, pero se ha optado por una conceptualizacin
 * diferente: exista una nica Pila. Si numeroActual es 0, la Pila se interpreta, y en caso 
 * contrario se compila.
 */

typedef struct _nodo{
	char tipo; /* 	(n)umero, i(d)entificador, (a)signacion
					(+), (*), (p)ila de for, (f)-print, (s)-pop
				*/
	union {
		int valor;
		Simbolo * ptrSimbolo;
		struct _nodo * pila;
	} datos;
	struct _nodo * ptrSig;
} Nodo;
typedef Nodo * Pila;
int numeroPilaActual=0;

int cima(Pila *p){
	int retorno=0;
	if (!(*p)||((*p)->tipo!='n'))
		printf("Error con la cima de la pila\n");
	else {
		Pila antiguo;
		retorno=(*p)->datos.valor;
		antiguo=(*p);
		(*p)=(*p)->ptrSig;
		free(antiguo);
	};
	return retorno;
}

void insertaPilaNUM(Pila * p, int valor){
	Nodo * nuevo = (Nodo *)malloc(sizeof(Nodo));
	nuevo->tipo='n';
	nuevo->datos.valor=valor;
	nuevo->ptrSig=(*p);
	(*p)=nuevo;
}

void insertaPilaPRINT(Pila * p){
	if(!numeroPilaActual){
		int c=0;
		c=cima(p);
		printf("Valor: %d\n", c);
		insertaPilaNUM(p, c);
	} else {
		Nodo * nuevo = (Nodo *)malloc(sizeof(Nodo));
		nuevo->tipo='f';
		nuevo->ptrSig=(*p);
		(*p)=nuevo;
	}
}

void insertaPilaPOP(Pila * p){
	if(!numeroPilaActual){
		cima(p);
	} else {
		Nodo * nuevo = (Nodo *)malloc(sizeof(Nodo));
		nuevo->tipo='s';
		nuevo->ptrSig=(*p);
		(*p)=nuevo;
	}
}

void insertaPilaID(Pila * p, Simbolo * id){
	if(!numeroPilaActual){
		insertaPilaNUM(p, id->valor);
	} else {
		Nodo * nuevo = (Nodo *)malloc(sizeof(Nodo));
		nuevo->tipo='d';
		nuevo->datos.ptrSimbolo=id;
		nuevo->ptrSig=(*p);
		(*p)=nuevo;
	}
}

void insertaPilaDEF(Pila * p, Simbolo * id){
	if(!numeroPilaActual){
		id->valor=cima(p);
	} else {
		Nodo * nuevo = (Nodo *)malloc(sizeof(Nodo));
		nuevo->tipo='a';
		nuevo->datos.ptrSimbolo=id;
		nuevo->ptrSig=(*p);
		(*p)=nuevo;
	}
}

void insertaPilaMas(Pila * p){
	if(!numeroPilaActual){
		insertaPilaNUM(p, cima(p)+cima(p));
	} else {
		Nodo * nuevo = (Nodo *)malloc(sizeof(Nodo));
		nuevo->tipo='+';
		nuevo->ptrSig=(*p);
		(*p)=nuevo;
	}
}

void insertaPilaPor(Pila * p){
	if(!numeroPilaActual){
		insertaPilaNUM(p, cima(p)*cima(p));
	} else {
		Nodo * nuevo = (Nodo *)malloc(sizeof(Nodo));
		nuevo->tipo='+';
		nuevo->ptrSig=(*p);
		(*p)=nuevo;
	}
}

void procesaPila(Pila * p, Pila ps);
void insertaPilaPila(Pila * p, Pila ps){
	if(!numeroPilaActual){
		int inc, vf, vi, i;
		inc=cima(p);
		vf=cima(p);
		vi=cima(p);
		for(i=vi;i<=vf;i+=inc){
			insertaPilaNUM(p, i);
			procesaPila(p, ps);
		}
	} else {
		Nodo * nuevo = (Nodo *)malloc(sizeof(Nodo));
		nuevo->tipo='p';
		nuevo->datos.pila=ps;
		nuevo->ptrSig=(*p);
		(*p)=nuevo;
	}
}

void procesaPila(Pila * p, Pila ps){
	if(ps){
		procesaPila(p, ps->ptrSig);
		if 		(ps->tipo=='n')	{ insertaPilaNUM(p, ps->datos.valor);
		}else if (ps->tipo=='d'){ insertaPilaID(p, ps->datos.ptrSimbolo);
		}else if (ps->tipo=='a'){ insertaPilaDEF(p, ps->datos.ptrSimbolo);
		}else if (ps->tipo=='*'){ insertaPilaPor(p);
		}else if (ps->tipo=='+'){ insertaPilaMas(p);
		}else if (ps->tipo=='f'){ insertaPilaPRINT(p);
		}else if (ps->tipo=='s'){ insertaPilaPOP(p);
		}else					{ insertaPilaPila(p, ps->datos.pila);
		}
	};
}
